#include	"microview.h"

int nextstr( T_BUFP* );
int previousstr( T_BUFP*, int );

int
nextstr( bp )
T_BUFP *bp;
{
	unsigned char	**lp= bp->lp, *ptr= bp->inputbuf;
	int	i= HS_WindowGetHomeY(bp->bwp)/bp->font_z+1,
		len= n_strlen( ptr );
	if( !*ptr )
		return	FALSE;
	for( lp+= i ; i< bp->line ; i++ ){
		unsigned char	*p= *lp++;
		int	j= n_strlen( p ) - len;
		for(; j-- >= 0 ; p++ ){
			if( *p == *ptr && !n_fstrcmp( ptr+1, p+1 ) ){
				WindowSetHome( bp->bwp, 0, i*bp->font_z );
				WindowRedraw( bp->bwp );
				return	TRUE;
			}
		}
	}
	ConsoleOpen();
	ConsolePrint( "tview:݂܂ł\r\n" );
	return	FALSE;
}

int
previousstr( bp, nextflg )
T_BUFP *bp;
int nextflg;
{
	unsigned char	**lp= bp->lp, *ptr= bp->inputbuf;
	int	i= HS_WindowGetHomeY(bp->bwp)/bp->font_z - 1,
		len= n_strlen( ptr );
	if( !*ptr )
		return	FALSE;
	if( !nextflg )
    	i += HS_WindowGetViewSizeY( bp->bwp )/bp->font_z + 1;
	for( lp+= i ; i >= 0; i-- ){
		unsigned char	*p= *lp--;
		int	j= n_strlen( p ) - len;
		for(; j-- >= 0 ; p++ ){
			if( *p == *ptr && !n_fstrcmp( ptr+1, p+1 ) ){
				WindowSetHome( bp->bwp, 0, i*bp->font_z );
				WindowRedraw( bp->bwp );
				return	TRUE;
			}
		}
	}
	ConsoleOpen();
	ConsolePrint( "tview:݂܂ł\r\n" );
	return	FALSE;
}
