/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"microview.h"

#define		DEFFONT		12
#define		DEFCOL		80
#define		DEFLIN		25
#define		DEFTAB		8

int	WindowHeapSize=	1024*1+512;

static T_BUFP	BD= {
		0, 0,
		DEFTAB, DEFTAB-1, DEFCOL, 0,
		DEFFONT/2, DEFFONT, DEFFONT,
		AttrDefault, AttrDefault&3,
		0, 0
	};

static int	x= 100,
		y= 0,
		h= -1,
		v= -1;


BPopen( file, flag )
char	*file;
{
	T_BUFP	*bp;
	char	*p;
	if( h < 0 || v < 0 ){
		h= BD.maxcol*BD.font_x+14;
		v= DEFLIN*BD.font_y;
	}
	if( flag || strchr( file, '\n' ) || strchr( file, '\r' ) ){
		p= VERSION;
		flag= 1;
	}else
		p= PathGetFullName( file );
	if( bp= (void*)malloc( sizeof(T_BUFP)+strlen(p)+1 ) ){
		*bp= BD;
		strcpy( bp->fname, p );
		if( !flag )
			flag= ReadFile( bp );
		else
			flag= SetBuf( bp, file );
		if( flag ){
			MV_Open( x, y, h, v, bp );
			return	TRUE;
		}
		free( bp );
	}else
		ConsoleAutoPrint( "tview:HEAPs\r\n" );
	return	FALSE;
}

WindowMain( argc, argv )
int	argc;
char	**argv;
{
/*	argc= AnalyzeArgs( argc, (char**)argv, &x, &y, &h, &v );*/
	int	rx, ry;
	WindowGetRootScroll( &rx, &ry );
	for(; --argc ;){
		if( **++argv == '-' ){
			switch( (*argv)[1] ){
			case 'x':
				x= _atoiX( *argv+2 )+rx;
				break;
			case 'y':
				y= _atoiX( *argv+2 )+ry;
				break;
			case 'h':
				h= _atoiX( *argv+2 );
				break;
			case 'v':
				v= _atoiX( *argv+2 );
				break;
			case 't':
				BD.tabsize= _atoiX(*argv+2);
				BD.tabmask= BD.tabsize-1;
				break;
			case 'a':
				BD.attr= _atoiX(*argv+2);
				BD.backattr= BD.attr & AttrReverse ?
							BD.attr & 3 : 0;
				break;
			case 'c':
				BD.maxcol= _atoiX(*argv+2);
				break;
			case 'f':
				BD.font_z= BD.font_y= _atoiX(*argv+2);
				BD.font_x= BD.font_y/2;
				break;
			case 'F':
				BD.font_z= _atoiX(*argv+2);
				break;
			case 'C':
				BPopen( *argv+2, TRUE );
				break;
			}
		}else{
			BPopen( *argv, FALSE );
		}
	}
	if( !GlobalCount )
		WindowSendSignal( WindowProcessID, SignalKill, 0 );
}

